;-----------------------------------------------------------------------------------------------
; MMX and SSE2 Graphics Experiments by Jeff Cummings ( jeffwebgamer@hotmail.com )
; Inspired by Andre LaMothe and Michael Abrash and the following web site:
; http://www.ronybc.8k.com

.686p
.MMX
.XMM
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib

.data
ClassName db "apocalypse",0
AppName   db "Jeff's Breakout with Assembly Language - Rectangles built bit by bit (using two threads) :-)",0,0,0,0,0,0
maxx      dd 10               ; 123: values set on execution
maxy      dd 10               ; this thing is best for comparing
startx    dd 1
starty    dd 1
lenx      dd 6
leny      dd 5
velx      dd 4
vely      dd 3
yoffset   dd 40
fcount    dd 0
frcount   dd 0
found     dd  0
stop      dd  0
blocknumb dd 0
blocktotal dd 2
blocks    dd  40, 50, 250, 300, 350, 50, 120, 300
bminf     BITMAPINFO <<40,0,0,1,32,0,0,0,0,0,0>>
fps       db 128 dup (0)
fmat2     db "FPS: [%u]  Ball Location: [x=%u, y=%u] Breakout in progress. (http://www.jeffpowerweb.bravehost.com)",0

.data?
hInstance HINSTANCE ?
hwnd      LPVOID ?
wnddc     HDC ?
hFThread  HANDLE ?
hHeap     HANDLE ?
idThread1 DWORD ?
idThread2 DWORD ?
bitmap1   LPVOID ?
msg       MSG <>
wc        WNDCLASSEX <>

.code

FireThread:
    invoke SetThreadPriority,idThread1,THREAD_PRIORITY_HIGHEST
    invoke GetDC,hwnd
    mov wnddc,eax
    invoke GetProcessHeap
    mov hHeap,eax
    invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,3200000
    mov bitmap1,eax
; setup eax to be size of bitmap, for clearing later.
    mov eax, 1024           ; eax = 1024
    mov ebx, 768
    imul ebx                ; eax = 1024 * 768
    lea eax, [eax*4]        ; eax = 1024 * 768 * 4
    push eax                ; save eax for later.
    finit
;; LOOP BEGINNING









startblock:
; DRAW BLOCK ON SCREEN COLOR: RED!!!
    mov edi, bitmap1            ; (re)set pointer to index into bitmap beginning
    mov ebx, offset blocks      ; blocks    dd  40, 50, 20, 20, 90, 150, 20, 20
    mov eax, DWORD PTR [ebx]    ; eax points to (x1) in (x1,y1,lenx,leny) for blocks array
    shl eax, 2                  ; eax = (x1 * 4)
    add edi, eax                ; edi = edi + (x1 * 4)
    mov eax, DWORD PTR [ebx+4]  ; eax points to (y1) in (x1,y1,lenx,leny) for blocks array
    imul eax, maxx              ; eax = (y1 * maxx)
    shl eax, 2                  ; eax = (y1 * maxx * 4)
    add edi, eax                ; edi = edi + (x1 * 4) + (y1 * maxx * 4) ** bitmap coords (x1,y1)
    mov eax, DWORD PTR [ebx+8]  ; eax = lenx in (x1,y1,lenx,leny) for blocks array
    shl eax, 2                  ; eax = (lenx * 4)
    mov edx, maxx               ; edx = maxx
    shl edx, 2                  ; edx = (maxx * 4)
    sub edx, eax                ; edx = (maxx * 4) - (lenx * 4)
    mov yoffset, edx            ; yoffset = (maxx * 4) - (lenx * 4)
;    sub edi, yoffset            ; edi = bitmap1 + (x1 * 4) + (y1 * maxx * 4) - (maxx * 4) + (lenx * 4)
                                ; yes, the signs are correct, that last instruction was subtraction...
                                ; this instruction sets up edi for addition that takes place at beginning of loop
    mov edx, DWORD PTR [ebx+12] ; edx = leny (loop control variable in newline to blockdone segment.
newline:                        ; then DRAW BLOCK # of lines = leny
    mov ecx, DWORD PTR [ebx+8]
    mov eax, 00FF0000h
    cld
    rep stosd
    dec edx
    cmp edx, 0
    je blockdone
    add edi, yoffset
    jmp newline
blockdone:


startblock2:
; DRAW BLOCK ON SCREEN COLOR: RED!!!
    mov edi, bitmap1            ; (re)set pointer to index into bitmap beginning
    mov ebx, offset blocks      ; blocks    dd  40, 50, 20, 20, 90, 150, 20, 20
    mov eax, DWORD PTR [ebx+16]    ; eax points to (x1) in (x1,y1,lenx,leny) for blocks array
    shl eax, 2                  ; eax = (x1 * 4)
    add edi, eax                ; edi = edi + (x1 * 4)
    mov eax, DWORD PTR [ebx+20]  ; eax points to (y1) in (x1,y1,lenx,leny) for blocks array
    imul eax, maxx              ; eax = (y1 * maxx)
    shl eax, 2                  ; eax = (y1 * maxx * 4)
    add edi, eax                ; edi = edi + (x1 * 4) + (y1 * maxx * 4) ** bitmap coords (x1,y1)
    mov eax, DWORD PTR [ebx+24]  ; eax = lenx in (x1,y1,lenx,leny) for blocks array
    shl eax, 2                  ; eax = (lenx * 4)
    mov edx, maxx               ; edx = maxx
    shl edx, 2                  ; edx = (maxx * 4)
    sub edx, eax                ; edx = (maxx * 4) - (lenx * 4)
    mov yoffset, edx            ; yoffset = (maxx * 4) - (lenx * 4)
;    sub edi, yoffset            ; edi = bitmap1 + (x1 * 4) + (y1 * maxx * 4) - (maxx * 4) + (lenx * 4)
                                ; yes, the signs are correct, that last instruction was subtraction...
                                ; this instruction sets up edi for addition that takes place at beginning of loop
    mov edx, DWORD PTR [ebx+28] ; edx = leny (loop control variable in newline to blockdone segment.
newline2:                        ; then DRAW BLOCK # of lines = leny
    mov ecx, DWORD PTR [ebx+24]
    mov eax, 00FF0000h
    cld
    rep stosd
    dec edx
    cmp edx, 0
    je blockdone2
    add edi, yoffset
    jmp newline2
blockdone2:







; DRAW BALL ON SCREEN
    mov edi, bitmap1        ; (re) set point to index into bitmap beginning
    mov eax, startx         ; set eax to startx = 100
    shl eax, 2              ; eax = eax * 4 (size of 32-bit color pixel)
    add edi, eax            ; add eax to bitmap offset. (x,0)
    mov eax, starty         ; eax = starting y position.
    imul maxx               ; multiply by maxx (length of horizontal line across screen)
    shl eax, 2              ; multiply by 4
    add edi, eax            ; point edi to bitmap offset (x,y) !!

; set up and define yoffset (length of one x line, minus length of drawn line)
    mov ebx, lenx
    shl ebx, 2
    mov eax, maxx           ; eax = maxx
    shl eax, 2              ; eax = maxx * 4
    sub eax, ebx            ; eax = (maxx * 4) - (lenx * 4)
    mov yoffset, eax        ; yoffset = (maxx * 4) - (lenx * 4)

    sub edi, yoffset
    mov edx, leny

; DRAW BALL (SMALL BLOCK THAT MOVES)
new:
    add edi, yoffset
    mov ecx, lenx
    mov eax, 0000D0FFh
    cld
    rep stosd
    dec edx
    cmp edx, 0
    je done
    jmp new
done:

; MOVE SMALL BLOCK AND BOUNCE OFF SCREEN BOUNDARIES
; add velx to startx
    mov eax, startx
    add eax, velx
    cmp eax, 1
    jg notxzero1
    neg velx
notxzero1:
    mov startx, eax
    add eax, lenx
    cmp eax, maxx
    jl notmaxx1
    neg velx
notmaxx1:
; add vely to starty
    mov eax, starty
    add eax, vely
    cmp eax, 1
    jg notyzero1
    neg vely
notyzero1:  
    mov starty, eax
    add eax, leny
    cmp eax, maxy
    jl notmaxy1
    neg vely
notmaxy1:          

; CHECK BALL FOR BOUNCING OFF BLOCK
; (startx, starty)
; (b1x1, b1y1) (b1x1 + b1lenx, b1y1 + b1leny)

; START NEW CHECK
    mov edx, offset blocks
    mov eax, DWORD PTR [edx]
    mov ebx, startx
    add ebx, lenx
    sub eax, ebx
    cmp eax, velx
    jg nothitx
    neg eax
    cmp eax, velx
    jl hitx
    mov eax, DWORD PTR [edx]
    add eax, DWORD PTR [edx+8]
    sub eax, startx
    cmp eax, velx
    jl nothitx
    neg eax
    cmp eax, velx
    jg hitx
    jmp nothitx
; ball hit at startx = b1x1
hitx:
    mov eax, DWORD PTR [edx+4]
    cmp eax, starty
    jg nothitx
    add eax, DWORD PTR [edx+12]
    cmp eax, starty
    jl nothitx
    neg velx
nothitx:

; START NEW CHECK
    mov eax, DWORD PTR [edx+4]  ; b1y1
    mov ebx, starty
    add ebx, leny
    sub eax, ebx
    cmp eax, vely
    jg nothity
    neg eax
    cmp eax, vely
    jl hity
    mov eax, DWORD PTR [edx+4]  ; b1y1
    add eax, DWORD PTR [edx +12] ; b1leny
    sub eax, starty
    cmp eax, vely
    jl nothity
    neg eax
    cmp eax, vely
    jg hity
    jmp nothity
; ball hit at starty = b1y1
hity:
    mov eax, DWORD PTR [edx] ; b1x1
    cmp eax, startx
    jg nothity
    add eax, DWORD PTR [edx+8] ; b1lenx
    cmp eax, startx
    jl nothity
    neg vely
nothity:

; 2 CHECK BALL FOR BOUNCING OFF BLOCK
; (startx, starty)
; (b1x1, b1y1) (b1x1 + b1lenx, b1y1 + b1leny)

; 2 START NEW CHECK
    mov edx, offset blocks
    mov eax, DWORD PTR [edx+16]
    mov ebx, startx
    add ebx, lenx
    sub eax, ebx
    cmp eax, velx
    jg nothitx2
    neg eax
    cmp eax, velx
    jl hitx2
    mov eax, DWORD PTR [edx+16]
    add eax, DWORD PTR [edx+24]
    sub eax, startx
    cmp eax, velx
    jl nothitx2
    neg eax
    cmp eax, velx
    jg hitx2
    jmp nothitx2
; ball hit at startx = b1x1
hitx2:
    mov eax, DWORD PTR [edx+20]
    cmp eax, starty
    jg nothitx2
    add eax, DWORD PTR [edx+28]
    cmp eax, starty
    jl nothitx2
    neg velx
nothitx2:

; START NEW CHECK
    mov eax, DWORD PTR [edx+20]  ; b1y1
    mov ebx, starty
    add ebx, leny
    sub eax, ebx
    cmp eax, vely
    jg nothity2
    neg eax
    cmp eax, vely
    jl hity2
    mov eax, DWORD PTR [edx+20]  ; b1y1
    add eax, DWORD PTR [edx + 28] ; b1leny
    sub eax, starty
    cmp eax, vely
    jl nothity2
    neg eax
    cmp eax, vely
    jg hity2
    jmp nothity2
; ball hit at starty = b1y1
hity2:
    mov eax, DWORD PTR [edx+16] ; b1x1
    cmp eax, startx
    jg nothity2
    add eax, DWORD PTR [edx+24] ; b1lenx
    cmp eax, startx
    jl nothity2
    neg vely
nothity2:

; DISPLAY SCREEN TO USER
    invoke SetDIBitsToDevice,wnddc,0,0,maxx,maxy,\
           0,0,0,maxy,bitmap1,ADDR bminf,DIB_RGB_COLORS

; CLEAR SCREEN FOR NEXT FRAME TO BE WRITTEN
    pop eax
    push eax
    invoke RtlZeroMemory,bitmap1,eax
;    invoke Sleep, 12
    
; DISPLAY STATS TO COMMAND WINDOW STATUS BAR OR TITLE BAR ATOP PAGE
    inc fcount                 ; count the frames
    invoke wsprintf, ADDR fps, ADDR fmat2,frcount,startx,starty
    invoke SetWindowText,hwnd,ADDR fps

    mov eax,stop                ; check for exit
    test eax,eax
    jz startblock


;; END


    invoke ReleaseDC,hwnd,wnddc 
    invoke HeapFree,hHeap,0,bitmap1
    mov idThread1,-1
    invoke ExitThread,2003
    hlt                        ; ...! i8085 memories
; -------------------------------------------------------------------------
.code

MoniThread:
    invoke Sleep,1000
    mov eax, fcount
    mov frcount, eax        ;; frcount is frames/second counter sent to firethread.
    xor eax,eax
    mov fcount,eax
    mov eax,stop
    test eax,eax
    jz MoniThread
    mov idThread2,-1
    invoke ExitThread,2003

; -------------------------------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    .IF uMsg==WM_CLOSE
        mov stop,1                  ; stop running threads
        invoke Sleep,100            ; avoid FireThread drawing without window
        invoke DestroyWindow,hwnd
        invoke PostQuitMessage,0
    .ELSEIF uMsg==WM_SIZE
	xor edx, edx
	mov eax, lParam
	mov dx, ax
	shr eax, 16
	shr edx, 2
	shl edx, 2
	mov maxx, edx
	mov maxy, eax
	mov bminf.bmiHeader.biWidth, edx
	neg eax
	mov bminf.bmiHeader.biHeight, eax
    .ELSE
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam        
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc ENDP
; -------------------------------------------------------------------------

start:
    invoke GetModuleHandle,NULL
    mov hInstance,eax
    mov wc.hInstance,eax
    mov wc.cbSize,SIZEOF WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNCLIENT
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov wc.hbrBackground,COLOR_MENUTEXT
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET ClassName
    invoke LoadCursor,NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke LoadIcon,hInstance,500
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke RegisterClassEx,ADDR wc
    invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,ADDR ClassName,ADDR AppName,\
                          WS_OVERLAPPEDWINDOW,0,0,720,500,NULL,NULL,\
                          hInstance,NULL
    mov hwnd,eax
    invoke ShowWindow,hwnd,SW_SHOWNORMAL
    invoke UpdateWindow,hwnd
    finit
    invoke CreateThread,0,4096,ADDR MoniThread,0,0,ADDR idThread1
    invoke CreateThread,0,4096,ADDR FireThread,0,0,ADDR idThread2
    mov hFThread,eax
    MsgLoop:
        invoke GetMessage,ADDR msg,0,0,0
        test eax,eax
        jz EndLoop
        invoke TranslateMessage,ADDR msg
        invoke DispatchMessage,ADDR msg
        jmp MsgLoop
    EndLoop:
    @@: mov eax,idThread1
        or  eax,idThread2
        not eax
        and eax,eax
        jnz @B
    invoke ExitProcess,eax

end start
